/**
 * HighlightSource Class (HSource)
 * This Object can be deSerialized to HRange.
 * Also it has the ability for persistence.
 */ function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
import HighlightRange from "@src/model/range/index";
import { queryElementNode, getTextChildByOffset } from "@src/model/source/dom";
var HighlightSource = /*#__PURE__*/ function() {
    "use strict";
    function HighlightSource(startMeta, endMeta, text, id, extra) {
        _classCallCheck(this, HighlightSource);
        this.startMeta = startMeta;
        this.endMeta = endMeta;
        this.text = text;
        this.id = id;
        this.__isHighlightSource = {};
        if (extra) {
            this.extra = extra;
        }
    }
    var _proto = HighlightSource.prototype;
    _proto.deSerialize = function deSerialize($root, hooks) {
        var _queryElementNode = queryElementNode(this, $root), start = _queryElementNode.start, end = _queryElementNode.end;
        var startInfo = getTextChildByOffset(start, this.startMeta.textOffset);
        var endInfo = getTextChildByOffset(end, this.endMeta.textOffset);
        if (!hooks.Serialize.Restore.isEmpty()) {
            var res = hooks.Serialize.Restore.call(this, startInfo, endInfo) || [];
            startInfo = res[0] || startInfo;
            endInfo = res[1] || endInfo;
        }
        var range = new HighlightRange(startInfo, endInfo, this.text, this.id, true);
        return range;
    };
    return HighlightSource;
}();
export default HighlightSource;

//# sourceMappingURL=index.js.map