/**
 * all constants
 * cSpell:ignore mengshou
 */ function _assertThisInitialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
}
function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assertThisInitialized(self);
}
function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _setPrototypeOf(o, p);
}
var _typeof = function(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
};
function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _getPrototypeOf(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result);
    };
}
import camel from "@src/util/camel";
import EventEmitter from "@src/util/event.emitter";
export var ID_DIVISION = ";";
export var LOCAL_STORE_KEY = "highlight-mengshou";
export var STYLESHEET_ID = "highlight-mengshou-style";
export var DATASET_IDENTIFIER = "highlight-id";
export var DATASET_IDENTIFIER_EXTRA = "highlight-id-extra";
export var DATASET_SPLIT_TYPE = "highlight-split-type";
export var CAMEL_DATASET_IDENTIFIER = camel(DATASET_IDENTIFIER);
export var CAMEL_DATASET_IDENTIFIER_EXTRA = camel(DATASET_IDENTIFIER_EXTRA);
export var CAMEL_DATASET_SPLIT_TYPE = camel(DATASET_SPLIT_TYPE);
var DEFAULT_WRAP_TAG = "span";
export var getDefaultOptions = function() {
    return {
        $root: document || document.documentElement,
        exceptSelectors: null,
        wrapTag: DEFAULT_WRAP_TAG,
        verbose: false,
        style: {
            className: "highlight-mengshou-wrap"
        }
    };
};
export var getStylesheet = function() {
    return "\n    .".concat(getDefaultOptions().style.className, " {\n        background: #ff9;\n        cursor: pointer;\n    }\n    .").concat(getDefaultOptions().style.className, ".active {\n        background: #ffb;\n    }\n");
};
export var ROOT_IDX = -2;
export var UNKNOWN_IDX = -1;
export var INTERNAL_ERROR_EVENT = "error";
var ErrorEventEmitter = /*#__PURE__*/ function(EventEmitter) {
    "use strict";
    _inherits(ErrorEventEmitter, EventEmitter);
    var _super = _createSuper(ErrorEventEmitter);
    function ErrorEventEmitter() {
        _classCallCheck(this, ErrorEventEmitter);
        return _super.apply(this, arguments);
    }
    return ErrorEventEmitter;
}(EventEmitter);
export var eventEmitter = new ErrorEventEmitter();

//# sourceMappingURL=const.js.map